SystemOrganization addCategory: #'Khami-Web'!

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'css' stamp: 'StuartHerring 1/16/2011 10:03'!
styleCss
	^'html {
background: lightblue;
}

table.gameBoard {
border-collapse: collapse;
}

table.gameBoard td {
width: 6em;
height: 6em;
font-size: 1em;
}

table.gameBoard td.available {
	background-color: white;
}
table.gameBoard td.available:hover {
	background-color: lightgrey;
}
table.gameBoard td.available a {
display: block;
margin: 0;
height: 100%;
width: 100%
text-decoration: none;
}

table.KmTile {
display: inline-block;
	border: 1px black solid;
border-collapse: collapse;
padding: 0;
}

table.KmTile td {
width: 1em;
height: 1em;
background-color:lightgrey;
}


.KmTile td.KmFarmRegion {
	background: green;
}
.KmTile td.KmVillageRegion {
	background: brown;
}
.KmTile td.KmRoadPath {
	background: white;
}

'! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
at: row at: column
	^game board at: row at: column! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
columns 
	^game board columns! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:45'!
initializeWithGame: aGame
	self initialize.
	game:= aGame! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:50'!
placeTileAt: row at: column
	game placeTileAt: row at: column! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 09:58'!
renderAvailableSpotFor: row at: column on: html
	html tableData class: #available; with: [
		html anchor callback: [ self placeTileAt: row at: column];
		with: [html space]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 09:54'!
renderBlankSpotOn: html
	html tableData: [html space]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 20:10'!
renderContentOn: html.
	html table border: 1; class: 'gameBoard';with: [
		(1 to: self rows) do: [ :r |
			html tableRow: [
				(1 to: self columns) do: [ :c |
					self renderTileAt: r at: c on: html]]]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:42'!
renderOccupiedSpotFor: aTile on: html
	html tableData: [
		html render: (KmTileRenderable for: aTile)]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 20:25'!
renderTileAt: row at: column on: html
	(self tileIsValidAt: row at: column)
		ifTrue: [self renderAvailableSpotFor: row at: column on: html]
		ifFalse: [ | tile |
			tile := self at: row at: column.
			tile isNil 
				ifTrue: [self renderBlankSpotOn: html]
				ifFalse: [self renderOccupiedSpotFor: tile on: html]]! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:48'!
rows
	^game board rows! !

!KmGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 22:49'!
tileIsValidAt: row at: column
	| regions gameBoard |
	game currentTile ifNil: [^false].
	gameBoard := game board.
	^gameBoard canPlaceTile: game currentTile at: row at: column.! !

WAComponent subclass: #KmHome
	instanceVariableNames: 'gameBoard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmHome class methodsFor: 'testing' stamp: 'StuartHerring 1/7/2011 14:42'!
canBeRoot
	^true! !

!KmHome class methodsFor: 'testing' stamp: 'StuartHerring 1/15/2011 16:30'!
initialize
	| app |
	WAAdmin register: self asApplicationAt: 'vok'.
	WADispatcher default defaultName: 'vok'.
	app := WADispatcher default defaultHandler.
	app preferenceAt: #sessionClass put: KmSession ! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 10:40'!
children
	^Array with: gameBoard! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 10:40'!
initialize
	super initialize.
	gameBoard := KmGameBoardComponent for: self session game.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/18/2011 19:44'!
renderContentOn: html
	self renderMenuOn: html.
	self session currentTile ifNotNil: [ html render: (KmTileRenderable for: self session currentTile)].
	self renderGameBoardOn: html.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:37'!
renderMenuItem: text do: aBlock on: html
	html listItem: [html anchor callback: aBlock; with: text ]! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/18/2011 19:43'!
renderMenuOn: html
	| currentTile |
	currentTile := self session currentTile.
	html unorderedList 
		class: #menu;
		with: [
			self renderMenuItem: 'Show Remaining Tiles' do: [ self showRemaining ] on: html.
			((self session game remainingTiles size > 0) and: [ currentTile isNil])
				ifTrue: [ self renderMenuItem: 'Take tile' do: [self takeTile ] on: html].
			currentTile ifNotNil: [ self renderMenuItem: 'Rotate Tile' do: [self rotateTile] on: html ]]! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/18/2011 19:42'!
rotateTile
	self session currentTile rotate! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/9/2011 18:32'!
showRemaining
	self call: KmTileList new.! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 10:55'!
takeTile
	self session game takeTile! !

!KmHome methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 08:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTileList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 12:10'!
initialize
	super initialize.! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 12:12'!
renderContentOn: html
	html heading level: 2; with: 'Tiles Remaining'.	
	self session game remainingTiles do: [ :t |
		html render: (KmTileRenderable for: t)
	].
	html break.
	html anchor callback: [ self answer ]; with: 'Close'
! !

!KmTileList methodsFor: 'updating' stamp: 'StuartHerring 1/9/2011 18:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WASession subclass: #KmSession
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:42'!
currentTile
	^game currentTile! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:28'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initialize
	super initialize.
	self initializeGame.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initializeGame
	game := KmGame testGame.! !

Object subclass: #KmTileRenderable
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 17:10'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 09:21'!
renderBlankOn: html
	html tableData
		with: [html space]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 08:10'!
renderCornerOn: html
	html tableData: [html space]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 17:20'!
renderHorizontalPathAt: side on: html
	| cssClass |
	(tile pathAt: side) isTerminator
		ifTrue: [cssClass := (tile regionAt: side surroundingRegions first) class name]
		ifFalse: [ cssClass := (tile pathAt: side) class name].
	
	html tableData 
			colSpan: 2;
			class: cssClass;
			with: [html space]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 17:12'!
renderOn: html
	html table class: (KmTile class name); with: [
		html tableRow: [
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegion: (tile regionAt: TopLeft) on: html.
			self renderVerticalPathAt: Top on: html.
			self renderRegion: (tile regionAt: TopRight) on: html.
			self renderRegionOrBlankAt: TopRight on: html.
		].
		html tableRow: [ 
			self renderRegion: (tile regionAt: LeftTop) on: html.
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegionOrBlankAt: TopRight on: html.
			self renderRegion: (tile regionAt: RightTop) on: html.
		].
		html tableRow: [
			self renderHorizontalPathAt: Left on: html.
			self renderPath: (tile pathAt: Centre) on: html.
			self renderHorizontalPathAt: Right on: html
			].
		html tableRow: [ 
			self renderRegion: (tile regionAt: LeftBottom) on: html.
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderVerticalPathAt: Bottom on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
			self renderRegion: (tile regionAt: RightBottom) on: html.
		].
		html tableRow: [
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderRegion: (tile regionAt: BottomLeft) on: html.
			self renderRegion: (tile regionAt: BottomRight) on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
		]
	]	
! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 13:50'!
renderPath: aPath on: html
	html tableData 
		class: aPath class name asSymbol;
		with: [html space]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/15/2011 13:49'!
renderRegion: aRegion on: html
	html tableData 
		class: aRegion class name asSymbol;
		with: [html space]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 17:11'!
renderRegionOrBlankAt: region on: html.
	(tile regionAt: region) class = (tile regionAt: region clockwise) class
		ifTrue: [self renderRegion: (tile regionAt: region) on: html]
		ifFalse: [ self renderBlankOn: html]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 17:20'!
renderVerticalPathAt: side on: html
	| cssClass |
	(tile pathAt: side) isTerminator
		ifTrue: [cssClass := (tile regionAt: side surroundingRegions first) class name]
		ifFalse: [ cssClass := (tile pathAt: side) class name].
	
	html tableData 
			rowSpan: 2;
			class: cssClass;
			with: [html space]! !
KmHome initialize!
